#!/bin/bash


# params:
# 1 - carousel directory name
# 2 - association aka common tag (referenced by PMT and AIT into psi-config.py)
# 3 - modules version
# 4 - pid (referenced by PMT into psi-config.py)
# 5 - carousel id 
    
#set up dirs
/bin/mkdir ./ocmod/$1
/bin/mkdir ./ocsec/$1

#create modules
/usr/local/bin/file2mod.py ./$1 ./ocmod/$1 $5 $5 $2 $3

#compress modules
for file in ./ocmod/$1/*.mod
do
    /usr/bin/du --apparent-size --block-size 1 $file > $file.size
    /usr/local/bin/zpipe < $file > $file.z 
    /bin/mv $file.z $file
done

#create sections
/usr/local/bin/mod2sec.py ./ocmod/$1 ./ocsec/$1

#enqueue sections in a single file
for file in ./ocsec/$1/* 
do
    /bin/echo $file
    /bin/cat $file >> ./$1/oc.sec
done

#create carousel transport stream   
/usr/local/bin/sec2ts $4 < ./$1/oc.sec > ./$1.ts
    
#clean from temp files
/bin/rm ./$1/oc.sec
/bin/rm ./ocmod/$1/*
/bin/rmdir ./ocmod/$1
/bin/rm ./ocsec/$1/*
/bin/rmdir ./ocsec/$1
