#!/bin/bash

# generate many psi tables
./psi-config.py

# generate dsmcc stream event example
./ste.py

# generate carousel from 3 directories: ocdir1, ocdir2, ocdir3, first is compressed
./oc-compress-update.sh ocdir1 0xB 1 2002 1 # <<<<<<<<<< paramenters are referenced by PMT and AIT
./oc-update.sh ocdir2 0xC 1 2003 2 # <<<<<<<<<< paramenters are referenced by PMT and AIT
./oc-update.sh ocdir3 0xD 1 2004 3 # <<<<<<<<<< paramenters are referenced by PMT and AIT

# create some fifo to stream TS from a tool to another tools
/usr/bin/mkfifo ./fifoocdir1.ts
/usr/bin/mkfifo ./fifoocdir2.ts
/usr/bin/mkfifo ./fifoocdir3.ts
/usr/bin/mkfifo ./fifooc.ts
/usr/bin/mkfifo ./fifoshaped.ts
/usr/bin/mkfifo ./fifotimed.ts
/usr/bin/mkfifo ./fifoinput.ts

# launch many tsloop that will repeat the same TS fixing cc errors write the TS in their own FIFO
/usr/local/bin/tsloop ./ocdir1.ts > ./fifoocdir1.ts &
/usr/local/bin/tsloop ./ocdir2.ts > ./fifoocdir2.ts &
/usr/local/bin/tsloop ./ocdir3.ts > ./fifoocdir3.ts &

# tscbrmuxer: muxes carousels at the bitrate specified, the result is a TS with the bitrate equals to the addition of all the bitrates
/usr/local/bin/tscbrmuxer b:139872 ./fifoocdir1.ts b:645096 ./fifoocdir2.ts b:215032 ./fifoocdir3.ts > ./fifooc.ts &

# tsloop repeat a CBR TS with an audio/video generated by MainConcept's mpeg2 encoder stripped from PSI packets and filled with null packets 
/usr/local/bin/tsloop ./input.ts > ./fifoinput.ts &

# tsnullshaper: changes dynamically input file null packets with the PSI and the muxed object carousel
/usr/local/bin/tsnullshaper ./fifoinput.ts +./fifooc.ts t:40 ./pat.ts t:40 ./pmt.ts t:100 ./eit.ts t:500 ./ait.ts t:200 ./sdt.ts t:200 ./nit.ts t:500 ./tdt.ts t:10000 ./ste.ts > ./fifoshaped.ts &

# restamp time and date
/usr/local/bin/tstdt ./fifoshaped.ts > ./fifotimed.ts &

# output final tool, you should add the final command line for your hw, check readme.txt for hw
/bin/echo "/usr/local/bin/your-tool ./fifotimed.ts -param bitrate"


