
#
# Copyright (C) 2005  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


import psimain
from dvbobjects.MHP.AIT import *
from dvbobjects.MHP.Descriptors import *
from dvbobjects.DVB.Descriptors import *
from dvbobjects.MPEG.Descriptors import *

#
# AIT
#

# define applications
application1 = application_loop_item( 
	organisation_id = 10, 
	application_id = 1000, 
	application_control_code = 2, # PRESENT
#	application_control_code = 1, # AUTOSTART
	application_descriptors_loop = [
		psimain.transport_protocolB_ds,
		application_descriptor(
			application_profile = 0x0001,
			version_major = 1,
			version_minor = 0,
			version_micro = 2,
			service_bound_flag = 1,
			visibility = 3, 
			application_priority = 1,
			transport_protocol_labels = [psimain.transport_protocolB_ds.transport_protocol_label], 
		),
            application_name_descriptor(application_name = "Text input example"),
            dvb_j_application_descriptor(parameters = ["dvb://1/sample8"]),
            dvb_j_application_location_descriptor(
    		base_directory = "/",
		class_path_extension = "",
 		initial_class = "tv.cineca.apps.yambo.Wizard", 
    	    ),
        ]
)

application2 = application_loop_item( 
	organisation_id = 10, 
	application_id = 1001,
	application_control_code = 2, # PRESENT
	application_descriptors_loop = [
		psimain.transport_protocolD_ds,
		application_descriptor(
			application_profile = 0x0001,
			version_major = 1,
			version_minor = 0,
			version_micro = 2,
			service_bound_flag = 1,
			visibility = 3, 
			application_priority = 1,
			transport_protocol_labels = [psimain.transport_protocolD_ds.transport_protocol_label], 
		),
            application_name_descriptor(application_name = "Test stream event"),
            dvb_j_application_descriptor(parameters = []),
            dvb_j_application_location_descriptor(
    		base_directory = "/",
		class_path_extension = "",
 		initial_class = "Testste", 
    	    ),
        ]
)

application3 = application_loop_item( 
	organisation_id = 10, 
	application_id = 1002, 
	application_control_code = 2, # PRESENT
	application_descriptors_loop = [
		psimain.transport_protocolB_ds,
		application_descriptor(
			application_profile = 0x0001,
			version_major = 1,
			version_minor = 0,
			version_micro = 2,
			service_bound_flag = 1,
			visibility = 3, 
			application_priority = 1,
			transport_protocol_labels = [psimain.transport_protocolB_ds.transport_protocol_label], 
		),
            application_name_descriptor(application_name = "Class loading example"),
            dvb_j_application_descriptor(parameters = ["dvb://1/sample9"]),
            dvb_j_application_location_descriptor(
    		base_directory = "/",
		class_path_extension = "",
 		initial_class = "tv.cineca.apps.yambo.Wizard", 
    	    ),
        ]
)
	
#define ait1
sec = application_information_section(
	application_type = DVB_J_application_type,
	common_descriptor_loop = [],
	application_loop = [
		application1,
		application2,
		application3,
	],
	version_number = 1, 
	section_number = 0,
	last_section_number = 0,
	elementary_PID = psimain.ait1_stream.elementary_PID,
	filename = "ait1",
	repeat_time = "500", #milliseconds
)
