#! /usr/bin/env python

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from dvbobjects.DVB.DataCarousel import *

g1 = Group(
    PATH="DII-1.sec",
    transactionId = 0x80000002,
    downloadId    = 0x00000001,
    blockSize     = 4066,
    )
g1.set(descriptors = [name_descriptor(name="/this/is/datacarousel/1")])
g1.set(modules = [
         Module(
    	    INPUT="/etc/inittab",
    	    moduleId = 0x0001,
    	    moduleVersion = 0x00,
    	    descriptors = [name_descriptor(name="some.bin")],
	),
    ],
    )

g2 = Group(
    PATH="DII-2.sec",
    transactionId = 0x80000004,
    downloadId    = 0x00000002,
    blockSize     = 4066,
    )
g2.set(descriptors = [name_descriptor(name="/this/is/datacarousel/2")])
g2.set(modules = [
         Module(
    	    INPUT="/boot/vmlinuz",
    	    moduleId = 0x0010,
    	    moduleVersion = 0x00,
	    # assocTag = 0xB, if an object carousel
    	    descriptors = [name_descriptor(name="another.bin")],
	    # descriptors = [compress_descriptor(name="another.bin")], for a compressed module descriptor
    	    ),
    ],
    )

dsi = SuperGroup(
    PATH = "/",
    transactionId = 0x80000000,
    )
dsi.addGroup(g1)
dsi.addGroup(g2)

#dsi.generate("objectcarousel", srg_ior_file_content)
dsi.generate("datacarousel")

