
#
# Copyright (C) 2005  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


from dvbobjects.PSI.EIT import *
import psimain 


sec = event_information_section(
	table_id = EIT_ACTUAL_TS_PRESENT_FOLLOWING,
	service_id = psimain.service1.service_ID,
	transport_stream_id = psimain.transport_stream1.transport_stream_id, 
	original_network_id = psimain.transport_stream1.original_network_id,
	event_loop = [
		event_loop_item(
			event_id = 1,
			start_year = 107, # from 1900
			start_month = 2,
			start_day = 15,
			start_hours = 0x00,
			start_minutes = 0x00,
			start_seconds = 0x00,
			duration_hours = 0x23,
			duration_minutes = 0x00,
			duration_seconds = 0x00,
			running_status = 4, # running
			free_CA_mode = 0, # not scrambled
			event_descriptor_loop = [
				short_event_descriptor (
					ISO639_language_code = "ita", 
					event_name = "video1",
					text = "example video 1",
				)    
			],
		),	    	
	],
	version_number = 1,
	section_number = 0,
	last_section_number = 1, 
	elementary_PID = 18,
	filename = "eit",
	repeat_time = "500", #milliseconds
)

#
# EIT present
#

sec_follow = event_information_section(
	table_id = EIT_ACTUAL_TS_PRESENT_FOLLOWING,
	service_id = psimain.service1.service_ID,
	transport_stream_id = psimain.transport_stream1.transport_stream_id, 
	original_network_id = psimain.transport_stream1.original_network_id,
	event_loop = [
		event_loop_item(
			event_id = 2, 
			start_year = 107, # from 1900
			start_month = 12, 
			start_day = 15, 
			start_hours = 0x23,
			start_minutes = 0x30,
			start_seconds = 0x00,
			duration_hours = 0x12,
			duration_minutes = 0x00,
			duration_seconds = 0x00,
			running_status = 1, # not running
			free_CA_mode = 0, # not scrambled
			event_descriptor_loop = [
				short_event_descriptor (
					ISO639_language_code = "ita", 
					event_name = "video2",
					text = "example video 2",
				)    
			],
		),
	],
	version_number = 1,
	section_number = 1,
	last_section_number = 1,
	elementary_PID = 18,
	filename = "eit",
)
#
# EIT following
#

