#! /usr/bin/env python

#
# Copyright (C) 2007  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from os import *
from ocupdate import *
from secupdate import *

ShapeInput = ''
MuxInput = ''

# Justdvb-It tools encapsulation, you should need to change this

def ClockTransport():
	if not path.exists('./fifotimed.ts'): mkfifo('./fifotimed.ts')
	system('/usr/local/bin/tstdt ./fifoshaped.ts > ./fifotimed.ts &')
	
def InputTransport(fileinput): # tsloop repeat in a loop a CBR TS with an audio/video generated by MainConcept's mpeg2 encoder stripped from original PSI packets and filled with null packets 
	if not path.exists('./fifoinput.ts'): mkfifo('./fifoinput.ts')
	system('/usr/local/bin/tsloop ' + fileinput + ' > ./fifoinput.ts &')

def AddTableToNullShaper(sec):
	global ShapeInput
	ShapeInput += ' t:' + sec.repeat_time + ' ./' + sec.filename +'.ts'

def ShapeTransport(): # tsnullshaper: changes dynamically input file null packets with the PSI tables and the muxed object carousel
	if not path.exists('./fifoshaped.ts'): mkfifo('./fifoshaped.ts')
	system('/usr/local/bin/tsnullshaper ./fifoinput.ts +./fifooc.ts ' + ShapeInput  + ' > ./fifoshaped.ts &')
	
def AddCarouselToMux(oc, bitrate):
	global MuxInput
	MuxInput += ' b:' + bitrate + ' ./fifo' + oc + '.ts'
	if not path.exists('./fifo' + oc + '.ts'): mkfifo('./fifo' + oc + '.ts')
	system('/usr/local/bin/tsloop '  + oc + '.ts > ./fifo' + oc + '.ts &')

def MuxCarousels(): # tscbrmuxer: muxes carousels at the bitrate specified,  the result is a TS with the bitrate equals to the addition of all the bitrates, launch tsloop that will repeat the carousel fixing cc errors and writing the TS in their own FIFO
	global MuxInput
	if not path.exists('./fifooc.ts'): mkfifo('./fifooc.ts')
	system('/usr/local/bin/tscbrmuxer' + MuxInput + ' > ./fifooc.ts &')
	
def GenerateCarousel(oc, version, compression, data_stream, transport_protocol):
	UpdateCarousel(oc,  version,  compression, transport_protocol.component_tag, data_stream.elementary_PID, transport_protocol.transport_protocol_label)

def Shutdown():
	print "kill all justdvbit processes"
	system('killall -9 tstdt &')
	system('killall -9 tsloop &')
	system('killall -9 tsnullshaper &')
	system('killall -9 tscbrmuxer &')
	
