#! /usr/bin/env python

#
# Copyright (C) 2007  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os


from dvbobjects.PSI.SDT import *
import psimain


#
# SDT
#
sec = service_description_section(
	transport_stream_id = psimain.transport_stream1.transport_stream_id,
	original_network_id = psimain.transport_stream1.original_network_id,
	service_loop = [
		service_loop_item(
			service_ID = psimain.service1.service_ID,
			EIT_schedule_flag = 1,
			EIT_present_following_flag = 1,
			running_status = 4, # running
			free_CA_mode = 0, # unscrambled
			service_descriptor_loop = [
				service_descriptor(
					service_type = 1, # digital television service
					service_provider_name = "CINECA",
					service_name = "TEST CHANNEL",
				),    
			],
		),	
	],
	version_number = 1,
	section_number = 0,
	last_section_number = 0,   
	elementary_PID = 17,
	filename = "sdt",
	repeat_time = "200",
	)
#
# SDT
#
