#! /usr/bin/env python

#
# Copyright (C) 2007  Lorenzo Pallara, lpallara@cineca.it
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#                                  
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                  
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import getopt
import sys

# Section update functions, you shouldn't need to change this

def Usage(return_code = 1):
	print("Usage: %s\n"
		"1 - sec name"
		"for example: %s pmt1") % (
		sys.argv[0], sys.argv[0])
	sys.exit(return_code)

def UpdateSection(sec):
	if os.path.exists('./' + sec.filename + '.ts'):
		current_size = os.path.getsize('./' + sec.filename + '.ts')
	else:
		current_size = 0
	out = open('./' + sec.filename + '.sec', 'wb')
	out.write(sec.pack())
	out.flush
	out.close
	out = open('./' + sec.filename + '.sec', 'wb') # awful flush problem of python not fixed since years...
	out.close
	os.system('/usr/local/bin/sec2ts ' + str(sec.elementary_PID) + ' < ./' + sec.filename + '.sec > ./' + sec.filename + '.ts')
	sec.repeat_time = str(int(sec.repeat_time) / (os.path.getsize('./' + sec.filename + '.ts')  / 188))
	if current_size > 0 and os.path.getsize('./' + sec.filename + '.ts') > current_size:
		print "Warning, %s table size changed, you should restart muxing!" % sec.filename


def UpdateSectionFollow(sec, sec_follow):
	if os.path.exists('./' + sec.filename + '.ts'):
		current_size = os.path.getsize('./' + sec.filename + '.ts')
	else:
		current_size = 0
	out = open('./' + sec.filename + '.sec', 'wb')
	out.write(sec.pack())
	out.flush
	out.close
	out = open('./' + sec.filename + '.sec', 'wb') # awful flush problem of python not fixed since years...
	out.close
	os.system('/usr/local/bin/sec2ts ' + str(sec.elementary_PID) + ' < ./' + sec.filename + '.sec > ./' + sec.filename + '.ts')		
	out = open('./' + sec_follow.filename + '.sec', 'wb')
	out.write(sec_follow.pack())
	out.flush
	out.close
	out = open('./' + sec_follow.filename + '.sec', 'wb') # awful flush problem of python not fixed since years...
	out.close
	os.system('/usr/local/bin/sec2ts ' + str(sec_follow.elementary_PID) + ' < ./' + sec_follow.filename + '.sec >> ./' + sec.filename + '.ts')
	sec.repeat_time = str(int(sec.repeat_time) / (os.path.getsize('./' + sec.filename + '.ts')  / 188))
	if current_size > 0 and os.path.getsize('./' + sec.filename + '.ts') > current_size:
		print "Warning, %s table size changed, you should restart muxing!" % sec.filename


if __name__ == '__main__':
	try:
		opts, args = getopt.getopt(sys.argv[1:], ' ')
	except getopt.error:
		Usage(0)
	if len(args) <> 1:
		Usage(0)
	sec_original = args[0]

	if os.path.exists("./sec.py"): os.remove("./sec.py")
	os.link("./" + sec_original + ".py", "./sec.py")

	import sec
	try:
		UpdateSectionFollow(sec.sec, sec.sec_follow)
	except AttributeError:
		UpdateSection(sec.sec)
	if os.path.exists("./sec.py"): os.remove("./sec.py")
	